library benchpress.src.reporter;

import "package:angular2/src/core/di.dart" show bind, provide, Provider;
import "package:angular2/src/facade/async.dart" show Future, PromiseWrapper;
import "package:angular2/src/facade/exceptions.dart"
    show BaseException, WrappedException;
import "measure_values.dart" show MeasureValues;

/**
 * A reporter reports measure values and the valid sample.
 */
abstract class Reporter {
  static List<Provider> bindTo(delegateToken) {
    return [
      bind(Reporter).toFactory((delegate) => delegate, [delegateToken])
    ];
  }

  Future<dynamic> reportMeasureValues(MeasureValues values) {
    throw new BaseException("NYI");
  }

  Future<dynamic> reportSample(
      List<MeasureValues> completeSample, List<MeasureValues> validSample) {
    throw new BaseException("NYI");
  }
}
