library benchpress.src.validator;

import "package:angular2/src/core/di.dart" show bind, provide, Provider;
import "package:angular2/src/facade/exceptions.dart"
    show BaseException, WrappedException;
import "measure_values.dart" show MeasureValues;

/**
 * A Validator calculates a valid sample out of the complete sample.
 * A valid sample is a sample that represents the population that should be observed
 * in the correct way.
 */
abstract class Validator {
  static List<Provider> bindTo(delegateToken) {
    return [
      bind(Validator).toFactory((delegate) => delegate, [delegateToken])
    ];
  }

  /**
   * Calculates a valid sample out of the complete sample
   */
  List<MeasureValues> validate(List<MeasureValues> completeSample) {
    throw new BaseException("NYI");
  }

  /**
   * Returns a Map that describes the properties of the validator
   * (e.g. sample size, ...)
   */
  Map<String, dynamic> describe() {
    throw new BaseException("NYI");
  }
}
